﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace VaxVoIP
{
    
    public partial class PhoneForm : UserControl
    {
        private cVaxSIPUserAgentExCOM m_objVaxUserAgent = null;
        private static PhoneForm m_objPhoneForm = null;

        public PhoneForm()
        {
            m_objPhoneForm = this;
            m_objVaxUserAgent = cVaxSIPUserAgentExCOM.GetOBJ();

            InitializeComponent();
        }

        public static PhoneForm GetOBJ()
        {
            return m_objPhoneForm;
        }

        private void PhoneForm_Load(object sender, RoutedEventArgs e)
        {
            
        }

        public void OnVaxOnline()
        {
            LoadPhoneNo();

            ComboDialCallSecureMediaSRTP.Items.Clear();
            ComboDialCallSecureMediaSRTP.Items.Add("Secure Media None");
            ComboDialCallSecureMediaSRTP.Items.Add("Secure Media Forced");
            ComboDialCallSecureMediaSRTP.SelectedIndex = 0;

            ComboAcceptCallSecureMediaSRTP.Items.Clear();
            ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media Auto");
            ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media None");
            ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media Forced");
            ComboAcceptCallSecureMediaSRTP.SelectedIndex = 0;
            
            ComboVoiceChanger.Items.Clear();
            ComboVoiceChanger.Items.Add("Disable");
            ComboVoiceChanger.Items.Add("Grandpa drunk");
            ComboVoiceChanger.Items.Add("Teen boy");
            ComboVoiceChanger.Items.Add("Household robot");
            ComboVoiceChanger.Items.Add("Helium inhaled");
            ComboVoiceChanger.Items.Add("Chipmunk");
            ComboVoiceChanger.SelectedIndex = 0;
            
            OnVaxForwardCallOnline();

            OnVaxVoiceOnline();
            OnVaxLineOnline();

            OnVaxToneOnline();
        }

        public void OnVaxOffline()
        {
            ListBoxStatusLog.Items.Clear();

            OnVaxIncomingCallOffline();

            OnVaxVoiceOffline();
            OnVaxLineOffline();
        }

        private void AddToStatusLog(String sStatusLog)
        {
            ListBoxStatusLog.Items.Add(sStatusLog);
        }

        private void BtnClearLog_Click(object sender, RoutedEventArgs e)
        {
            ListBoxStatusLog.Items.Clear();
        }

        ////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////

        public void OnDigitDTMF(int nLineNo, String sDigit)
        {
            AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Key-pressed: " + sDigit);
        }

        ////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////

        public void OnDetectedAMD(int nLineNo, Boolean bIsHuman)
        {
            if (!bIsHuman)
                AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Answering Machine [Yes]");
            else
                AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Answering Machine [No]");
        }

        public void OnNetworkReachability(bool bAvailable)
        {
            if (bAvailable)
                AddToStatusLog("Network is available");
            else
                AddToStatusLog("Network is not available");
        }

        private void LoadPhoneNo()
        {
            string sPhoneNo = "";

            cStorePhoneNo.GetPhoneNo(ref sPhoneNo);

            EditPhoneNo.Text = sPhoneNo;
        }

        private void AdjustSecureMediaSRTP(Boolean bDialCall)
        {
            int nSecureIndex = -1;

            if (bDialCall)
            {
                nSecureIndex = ComboDialCallSecureMediaSRTP.SelectedIndex;

                if (nSecureIndex == -1 || nSecureIndex == 0)
                {
                    m_objVaxUserAgent.CryptoMediaNONE(false);
                    return;
                }

                if (nSecureIndex == 1)
                {
                    m_objVaxUserAgent.CryptoMediaSDP(true);
                    return;
                }

                return;
            }

            nSecureIndex = ComboAcceptCallSecureMediaSRTP.SelectedIndex;

            if (nSecureIndex == -1 || nSecureIndex == 0)
            {
                m_objVaxUserAgent.CryptoMediaNONE(false);
                return;
            }

            if (nSecureIndex == 1)
            {
                m_objVaxUserAgent.CryptoMediaNONE(true);
                return;
            }

            if (nSecureIndex == 2)
            {
                m_objVaxUserAgent.CryptoMediaSDP(true);
                return;
            }
        }

        private void UpdateBtnStatus()
        {
            int nLineNo = ListBoxLines.SelectedIndex;

            if (!m_objVaxUserAgent.IsLineRecording(nLineNo) && BtnStartRecording.Content.ToString() != "Start")
                BtnStartRecording.Content = "Start";

            else if (m_objVaxUserAgent.IsLineRecording(nLineNo) && BtnStartRecording.Content.ToString() != "Stop")
                BtnStartRecording.Content = "Stop";


            if (!m_objVaxUserAgent.IsLineBusy(nLineNo) && BtnDial.Content.ToString() != "Dial")
                BtnDial.Content = "Dial";

            else if (m_objVaxUserAgent.IsLineBusy(nLineNo) && BtnDial.Content.ToString() != "Hangup")
                BtnDial.Content = "Hangup";


            if (!m_objVaxUserAgent.IsLineHold(nLineNo) && BtnHold.Content.ToString() != "Hold")
                BtnHold.Content = "Hold";

            else if (m_objVaxUserAgent.IsLineHold(nLineNo) && BtnHold.Content.ToString() != "UnHold")
                BtnHold.Content = "UnHold";
        }

        private void CheckDetectAMD_Click(object sender, RoutedEventArgs e)
        {
            m_objVaxUserAgent.DetectAMD(CheckDetectAMD.IsChecked.Value);
        }

        private void ComboVoiceChanger_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int nVoiceChangerType = ComboVoiceChanger.SelectedIndex;
            if (nVoiceChangerType == -1) return;

            switch (nVoiceChangerType)
            {
                case 0:
                    m_objVaxUserAgent.VoiceChanger(-1);
                    break;

                case 1:
                    m_objVaxUserAgent.VoiceChanger(4);
                    break;

                case 2:
                    m_objVaxUserAgent.VoiceChanger(8);
                    break;

                case 3:
                    m_objVaxUserAgent.VoiceChanger(12);
                    break;

                case 4:
                    m_objVaxUserAgent.VoiceChanger(16);
                    break;

                case 5:
                    m_objVaxUserAgent.VoiceChanger(20);
                    break;
            }
        }

        private void CheckDisturb_Click(object sender, RoutedEventArgs e)
        {
            m_objVaxUserAgent.DonotDisturb(CheckDisturb.IsChecked.Value);
        }

        /////////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////////

        private void ScrollViewer_OnListBoxScrollChanged(object sender, ScrollChangedEventArgs e)
        {
            if (e.OriginalSource is ScrollViewer && Math.Abs(e.ExtentHeightChange) > 0.0)
            {
                ScrollViewer hScroll = (ScrollViewer)e.OriginalSource;
                hScroll.ScrollToBottom();
            }
        }
    }
}
