﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace VaxVoIP
{
    public partial class PhoneForm : UserControl
    {
        cLineVoice[] m_aLineVoice;

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        public void OnVaxVoiceOnline()
        {
            int nTotalLine = m_objVaxUserAgent.GetTotalLine();

            m_aLineVoice = new cLineVoice[nTotalLine];

            for (int nLineNo = 0; nLineNo < nTotalLine; nLineNo++)
            {
                m_aLineVoice[nLineNo] = new cLineVoice();

            }

            CheckLeftSpkListen.IsChecked = true;
            CheckRightSpkListen.IsChecked = true;

            CheckAllowListenConf.IsChecked = true;
            CheckAllowSpeakConf.IsChecked = true;

            CheckMuteLineSPK.IsChecked = false;
            CheckMuteLineMIC.IsChecked = false;

            SliderSpkVol.Value = 100;
            SliderMicVol.Value = 100;

            m_objVaxUserAgent.AudioDeviceVU(true, true, true);
        }

        public void OnVaxVoiceOffline()
        {
            SpkProgBar.Value = 0;
            MicProgBar.Value = 0;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        private void CheckMuteLineSPK_Click(object sender, RoutedEventArgs e)
        {
            int nLineNo = ListBoxLines.SelectedIndex;

            Boolean bResult = m_objVaxUserAgent.MuteLineSpk(nLineNo, CheckMuteLineSPK.IsChecked.Value);
            if (!bResult) return;

            m_aLineVoice[nLineNo].m_bMuteLineSPK = CheckMuteLineSPK.IsChecked.Value;
        }

        private void CheckMuteLineMIC_Click(object sender, RoutedEventArgs e)
        {
            int nLineNo = ListBoxLines.SelectedIndex;

            Boolean bResult = m_objVaxUserAgent.MuteLineMic(nLineNo, CheckMuteLineMIC.IsChecked.Value);
            if (!bResult) return;

            m_aLineVoice[nLineNo].m_bMuteLineMIC = CheckMuteLineMIC.IsChecked.Value;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        private void CheckLeftSpkListen_Click(object sender, RoutedEventArgs e)
        {
            int nLineNo = ListBoxLines.SelectedIndex;

            if (CheckLeftSpkListen.IsChecked == false && CheckRightSpkListen.IsChecked == false)
                CheckRightSpkListen.IsChecked = true;

            Boolean bResult = m_objVaxUserAgent.LineVoiceChannelSpk(nLineNo, SpkListenChannel(CheckLeftSpkListen.IsChecked.Value, CheckRightSpkListen.IsChecked.Value));
            if (!bResult) return;

            m_aLineVoice[nLineNo].m_bListenLeftSpk = CheckLeftSpkListen.IsChecked.Value;
        }

        private void CheckRightSpkListen_Click(object sender, RoutedEventArgs e)
        {
            int nLineNo = ListBoxLines.SelectedIndex;

            if (CheckLeftSpkListen.IsChecked == false && CheckRightSpkListen.IsChecked == false)
                CheckLeftSpkListen.IsChecked = true;

            Boolean bResult = m_objVaxUserAgent.LineVoiceChannelSpk(nLineNo, SpkListenChannel(CheckLeftSpkListen.IsChecked.Value, CheckRightSpkListen.IsChecked.Value));
            if (!bResult) return;

            m_aLineVoice[nLineNo].m_bListenRightSpk = CheckRightSpkListen.IsChecked.Value;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        private void CheckAllowListenConf_Click(object sender, RoutedEventArgs e)
        {
            int nLineNo = ListBoxLines.SelectedIndex;

            Boolean bResult = m_objVaxUserAgent.ConfAllowLine(nLineNo, CheckAllowListenConf.IsChecked.Value, CheckAllowSpeakConf.IsChecked.Value);
            if (!bResult) return;

            m_aLineVoice[nLineNo].m_bAllowListenConf = CheckAllowListenConf.IsChecked.Value;
        }

        private void CheckAllowSpeakConf_Click(object sender, RoutedEventArgs e)
        {
            int nLineNo = ListBoxLines.SelectedIndex;

            Boolean bResult = m_objVaxUserAgent.ConfAllowLine(nLineNo, CheckAllowListenConf.IsChecked.Value, CheckAllowSpeakConf.IsChecked.Value);
            if (!bResult) return;

            m_aLineVoice[nLineNo].m_bAllowSpeakConf = CheckAllowSpeakConf.IsChecked.Value;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        private void CheckSpkMute_Click(object sender, RoutedEventArgs e)
        {
            m_objVaxUserAgent.MuteSpk(CheckSpkMute.IsChecked.Value);
        }

        private void CheckMuteMic_Click(object sender, RoutedEventArgs e)
        {
            m_objVaxUserAgent.MuteMic(CheckMuteMic.IsChecked.Value);
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        private void SliderSpkVol_Scroll(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            // Value range (-100) --- 0 --- (+100)

            m_objVaxUserAgent.SetVolumeSpk(Convert.ToInt32(SliderSpkVol.Value) - 100);
        }

        private void SliderMicVol_Scroll(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            // Value range (-100) --- 0 --- (+100)

            m_objVaxUserAgent.SetVolumeMic(Convert.ToInt32(SliderMicVol.Value) - 100);
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        private int SpkListenChannel(Boolean bListenLeft, Boolean bListenRight)
        {
            if (bListenLeft == true && bListenRight == false)
                return 0;

            if (bListenLeft == false && bListenRight == true)
                return 1;

            return 2;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        private void ListBoxLines_SelectedIndexChanged(object sender, RoutedEventArgs e)
        {
            int nLineNo = ListBoxLines.SelectedIndex;
            if (nLineNo == -1) return;

            CheckMuteLineMIC.IsChecked = m_aLineVoice[nLineNo].m_bMuteLineMIC;
            CheckMuteLineSPK.IsChecked = m_aLineVoice[nLineNo].m_bMuteLineSPK;

            CheckAllowListenConf.IsChecked = m_aLineVoice[nLineNo].m_bAllowListenConf;
            CheckAllowSpeakConf.IsChecked = m_aLineVoice[nLineNo].m_bAllowSpeakConf;

            CheckLeftSpkListen.IsChecked = m_aLineVoice[nLineNo].m_bListenLeftSpk;
            CheckRightSpkListen.IsChecked = m_aLineVoice[nLineNo].m_bListenRightSpk;

            UpdateBtnStatus();
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////

        public void OnAudioDeviceMicVU(int nLevelVU)
        {
            MicProgBar.Value = nLevelVU;
        }

        public void OnAudioDeviceSpkVU(int nLevelVU)
        {
            SpkProgBar.Value = nLevelVU;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////////////////////
    }

    public class cLineVoice
    {
        public Boolean m_bMuteLineMIC = false;
        public Boolean m_bMuteLineSPK = false;

        public Boolean m_bAllowListenConf = true;
        public Boolean m_bAllowSpeakConf = true;

        public Boolean m_bListenLeftSpk = true;
        public Boolean m_bListenRightSpk = true;

    }
}
